#include "FiveWin.ch"
#include "Visual.ch"

#ifdef __XPP__
   #define Super ::TWindow
#endif

memvar oIDE

//----------------------------------------------------------------//

CLASS TWndPrj FROM TWindow

   DATA   aPrograms    AS ARRAY  INIT {}
   DATA   aForms       AS ARRAY  INIT {}
   DATA   aDataBases   AS ARRAY  INIT {}

   DATA   cMainPrg
   DATA   cName

   DATA   oWndCode
   DATA   oBrw

   DATA   oHand        // BottonBar cursor used
   DATA   oDlgBuild    

   CLASSDATA lRegistered AS LOGICAL

   DATA   cCompiler INIT "c:\harbour\bin\harbour                   "
   DATA   cLibPath  INIT "c:\fwh\lib;c:\harbour\lib                             "
   DATA   cChPath   INIT "c:\harbour\include;c:\fwh\include        "
   DATA   cObjPath
   DATA   lMemVar, lWarnings, lDebug, lNoLines
   DATA   nLinker INIT 1
   DATA   nRcType, nRcPlace INIT 1
   DATA   lOneModule
   DATA   cLinker  INIT "ilink32.exe"
   DATA   lMapFile AS LOGICAL
   DATA   cRcName  INIT "brc32.exe"

   METHOD New( cName ) CONSTRUCTOR

   METHOD Build( lDebug )  // Builds the entire project
   METHOD BuildBar()
   METHOD Close()
   METHOD CompilerIni()
   METHOD LinkerIni()
   METHOD CompilerSave()
   METHOD LinkerSave()
   METHOD NewForm()

   METHOD Run( cArguments )
   METHOD Debug( cArguments ) INLINE ::Run( cArguments, .t. )

   METHOD Setup()
   METHOD AddItem()
   METHOD DelItem()
   METHOD GetItems()

   METHOD OpenForm( cFormName )

   METHOD SelItems( nOption )  // Changes visible items when TABs changes

   METHOD ResetClick()  INLINE ASend( ::aForms, "_bLClicked", nil )

   #ifndef __XPP__
      METHOD ResetCursor() INLINE ASend( ::aForms, "_SetCursor" )
   #else
      METHOD ResetCursor() INLINE ASend( ::aForms, "_SetCursor()" )
   #endif

   METHOD Save()

   #ifndef __XPP__
      METHOD Show() INLINE ASend( ::aForms, "Show" ), Super:Show()
   #else
      METHOD Show() INLINE ASend( ::aForms, "Show()" ), Super:Show()
   #endif

ENDCLASS

//----------------------------------------------------------------//

METHOD New( cName ) CLASS TWndPrj

   local oFont
   local cProject := '#include "FiveWin.ch"' + CRLF + CRLF + ;
      "//-----------------------------------------------------------------------//" + CRLF + CRLF + ;
      "function Main()" + CRLF + CRLF + ;
      "   public oApplication, oForm1" + CRLF + CRLF + ;
      "   oApplication = TApplication():New()" + CRLF + CRLF + ;
      "   oApplication:AddForm( oForm1 := TForm1():New() )" + CRLF + CRLF + ;
      "   oApplication:Run()" + CRLF + CRLF + ;
      "return nil" + CRLF + CRLF + ;
      "//-----------------------------------------------------------------------//"

   DEFAULT cName := "project1.fpr"

   DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -8

   ::cName    = cName
   ::cMainPrg = "form1.prg"

   Super:New( 18, 48, 40, 116, "Project manager: " + cName )

   DEFINE ICON ::oIcon RESOURCE "Project"

   DEFINE CURSOR ::oHand HAND
   
   ::BuildBar()

   @  1, 0 LISTBOX ::oBrw FIELDS "" ;
      HEADERS "", "Name", "Description" ;
      COLSIZES 15, 80, 200 ;
      FONT oFont ;
      OF Self

   ::oWndCode = oIDE:oWndCode
   ::oWndCode:AddPage( "project1.prg", cProject )
   AAdd( ::aPrograms, { "project1.prg", "" } )

   ::oBrw:SetArray( ::aPrograms )
   ::oBrw:bLine = { || ::GetItems() }
   ::oClient = ::oBrw

   @  5, 0 TABS ::oBottom ;
      ITEMS "&Programs", "&Forms", "&DataBases", "&Resources",;
            "&Files", "&Libraries" ;
      ACTION ::SelItems( nOption ) ;
      OF Self

   // We don't let this window be destroyed. We just hide it
   ::bValid = { || ::Hide(), .f. }

   ::CompilerIni()

return Self

//----------------------------------------------------------------//

METHOD Build( lDebug ) CLASS TWndPrj

   local oAction, oResult, cResult := "", oBtnCancel, n, lCancel := .f.
   local aFileInfo, cLinkFile := "", cRC := "", cFormName, cRCName

   DEFAULT lDebug := .f.

   if ! ::Save()
      return nil
   endif
   
   if ::oDlgBuild != nil
      ::oDlgBuild:End()
   endif   

   DEFINE DIALOG ::oDlgBuild RESOURCE "Build"

   REDEFINE SAY PROMPT ( "Project: " + ::cName ) ID ID_PROJECT OF ::oDlgBuild
   REDEFINE SAY oAction PROMPT ( "Compiling: " + ::aPrograms[ 1 ][ 1 ] ) ID ID_ACTION OF ::oDlgBuild
   REDEFINE GET oResult VAR cResult ID ID_RESULT OF ::oDlgBuild MEMO READONLY
   REDEFINE BUTTON oBtnCancel ID IDCANCEL ACTION ( lCancel := .t., ::oDlgBuild:End() )

   ACTIVATE DIALOG ::oDlgBuild CENTERED NOWAIT

   for n = 1 to Len( ::aPrograms )

      /*
      if File( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj" ) .and. ;
         FDate( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj" ) >= ;
         FDate( ::aPrograms[ n ][ 1 ] ) .and. ;
         FDate( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj" ) >= ;
         FDate( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".frm" ) .and. ;
         FTime( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj" ) >= ;
         FTime( ::aPrograms[ n ][ 1 ] ) .and. ;
         FTime( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj" ) >= ;
         FTime( cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".frm" )
      else */

         oAction:SetText( "Compiling: " + ::aPrograms[ n ][ 1 ] )
         MemoWrit( "comp_prg.bat",;
                   ::cCompiler + " " + ::aPrograms[ n ][ 1 ] + ;
                   " /n" + ;
                   If( lDebug, "/b", "" ) + " /i" + ::cChPath + " > comp_prg.log" ) // + CRLF + ;
                   // "type comp.log" ) // + CRLF + "pause" )
         WaitRun( "comp_prg.bat", 0 )
         oResult:SetText( cResult += CRLF + MemoRead( "comp_prg.log" ) )
         if "error" $ Lower( cResult )
            while ! lCancel
               SysRefresh()
            end
         endif
         MemoWrit( "comp_c.bat",;
                   "c:\bcc55\bin\bcc32 -c -Ic:\bcc55\bin\include;" + ::cChPath + ;
                   cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".c" ;
                   + " > comp_c.log" ) //  + CRLF + "type comp.log" ) // + CRLF + "pause" )
         WaitRun( "comp_c.bat", 0 )
         oResult:SetText( cResult += CRLF + MemoRead( "comp_c.log" ) )
      /* endif */

      if lCancel
         exit
      endif
   next

   // Now we compile the resources

   cRC += '1 ICON "form.ico"' + CRLF
   cRC += '1 24 "visualfw.man"' + CRLF
    
   for n = 1 to Len( ::aForms )
      cFormName = Lower( cFileNoExt( ::aForms[ n ]:cFileName ) )
      cRC += ::aForms[ n ]:cClassName + ' FORMS "' + cFormName + '.ffm"' + CRLF
   next   

   cRCName = Lower( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) ) + ".rc"
   MemoWrit( cRCName, cRC )
   MemoWrit( "comp_rc.bat", "c:\bcc55\bin\brc32 -r " + cRCName + " > comp_rc.log" ) // + CRLF + "pause" )                    
   WaitRun( "comp_rc.bat", 0 )
   oResult:SetText( cResult += CRLF + MemoRead( "comp_rc.log" ) )
 
   // Now we build the link file

   cLinkFile += "c0w32.obj +" + CRLF

   for n = 1 to Len( ::aPrograms )
      cLinkFile += cFileNoExt( ::aPrograms[ n ][ 1 ] ) + ".obj "
   next
   cLinkFile += ", +" + CRLF

   cLinkFile += Lower( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) ) + ".exe, +" + CRLF
   cLinkFile += Lower( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) ) + ".map, +" + CRLF

   cLinkFile += "c:\FWH\lib\FiveH.lib c:\FWH\lib\FiveHC.lib + " + CRLF

   cLinkFile += "c:\harbour\lib\hbrtl.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbvm.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\gtgui.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hblang.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbmacro.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbrdd.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\rddntx.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\rddcdx.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\rddfpt.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbsix.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbdebug.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbcommon.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbpp.lib + " + CRLF
   cLinkFile += "c:\harbour\lib\hbw32.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\cw32.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\psdk\odbc32.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\psdk\nddeapi.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\psdk\iphlpapi.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\psdk\msimg32.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\psdk\rasapi32.lib + " + CRLF
   cLinkFile += "c:\bcc55\lib\import32.lib," + CRLF

   cLinkFile += Lower( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) ) + ".res" + CRLF

   /* if File( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) + ".exe" ) .and. ;
      FDate( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) + ".exe" ) >= ;
      FDate( ::aPrograms[ 1 ][ 1 ] ) .and. ;
      FTime( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) + ".exe" ) >= ;
      FTime( ::aPrograms[ 1 ][ 1 ] )
      oAction:SetText( "up to date" )
   else */
      oAction:SetText( "Linking..." )
      MemoWrit( "b32.bc", cLinkFile )
      MemoWrit( "link32.bat", "c:\bcc55\bin\ilink32 -Gn -aa -Tpe -s @b32.bc > link.log" ) // + ;
                // CRLF + "type link.log" ) // + CRLF + "pause" )
      WaitRun( "link32.bat", 0 )
      oResult:SetText( cResult += CRLF + MemoRead( "link.log" ) )
      oAction:SetText( "Done" )
      if "Fatal" $ cResult .or. "Error" $ cResult
         oAction:SetText( "Linking errors" )
         while ! lCancel
            SysRefresh()
         end
      endif
   /* endif */

   // oDlg:End()
   oBtnCancel:SetText( "&Close" )

return nil

//----------------------------------------------------------------//

METHOD BuildBar() CLASS TWndPrj

   DEFINE BUTTONBAR ::oBar SIZE 30, 30 OF Self 2007

   DEFINE BUTTON OF ::oBar RESOURCE "additem" ;
      TOOLTIP "Add item" ;
      ACTION  ::AddItem() NOBORDER

   DEFINE BUTTON OF ::oBar RESOURCE "delete" ;
      TOOLTIP "Delete item" ;
      ACTION  ::DelItem() NOBORDER

   DEFINE BUTTON OF ::oBar GROUP RESOURCE "setup" ;
      TOOLTIP "Setup" ;
      ACTION ::Setup() NOBORDER

   DEFINE BUTTON OF ::oBar RESOURCE "build" ;
      TOOLTIP "Build" ;
      ACTION  ::Build() NOBORDER

   DEFINE BUTTON OF ::oBar RESOURCE "run" ;
      TOOLTIP "Run" ;
      ACTION  ::Run( oIde:cArguments ) NOBORDER

   DEFINE BUTTON OF ::oBar RESOURCE "debug" ;
      TOOLTIP "Debug" ;
      ACTION  ::Run( oIde:cArguments, .T. ) NOBORDER

   AEval( ::oBar:aControls, { | o | o:oCursor := ::oHand } )

return nil

//----------------------------------------------------------------//

METHOD NewForm() CLASS TWndPrj

   local oForm := TDesigner():New()

   local cCode := '#include "FiveWin.ch"' + CRLF + CRLF + ;
      "//-----------------------------------------------------------------------//" + CRLF + CRLF + ;
      "CLASS " + oForm:cClassName + " FROM TForm" + CRLF + CRLF + ;
      "   METHOD New() CONSTRUCTOR" + CRLF + CRLF + ;
      "ENDCLASS" + CRLF + CRLF + ;
      "//-----------------------------------------------------------------------//" + CRLF + CRLF + ;
      "METHOD New() CLASS " + oForm:cClassName + CRLF + CRLF + ;
      "   Super:New()" + CRLF + CRLF + ;
      "return Self" + CRLF + CRLF + ;
      "//-----------------------------------------------------------------------//"

      // '   #include "' + Lower( cFileNoExt( oForm:cFileName ) ) + '.frm"' + CRLF + CRLF + ;

   AAdd( ::aPrograms, { oForm:cPrgName, "" } )
   AAdd( ::aForms, oForm )
   oForm:oEdit = ::oWndCode:AddPage( oForm:cPrgName, cCode )

return oForm

//----------------------------------------------------------------//

METHOD OpenForm( cFormName ) CLASS TWndPrj

   local oForm, cPrgName

   if ! File( cFormName )
      MsgAlert( "Form " + cFormName + " not found!" )
      return nil
   endif

   if ! File( cPrgName := cFileNoExt( cFormName ) + ".prg" )
      MsgAlert( "Source code " + cPrgName + " of Form " + cFormName +  " not found!" )
      return nil
   endif

   oForm = TDesigner():New()
   oForm:Load( cFormName )

   AAdd( ::aForms, oForm )
   AEval( oForm:aControls, { | oCtl | oCtl:lDrag := .t. } )
   if Len( oForm:aControls ) > 0
      oForm:aControls[ 1 ]:CheckDots()
   endif

   oForm:Show()
   oForm:cFileName = cFormName
   oForm:cPrgName  = cPrgName

   if ::oWndCode == nil
      ::oWndCode = TWndCode():New( oForm )
   endif
   ::oWndCode:AddPage( cPrgName, MemoRead( cPrgName ) )

return oForm

//----------------------------------------------------------------//

METHOD Close() CLASS TWndPrj

   local n

   for n = 1 to Len( ::aForms )
       ::aForms[ n ]:bValid = { || .t. }
       ::aForms[ n ]:End()
   next

   ::aForms[ 1 ]:nForms = 0  // reset CLASSDATA nForms
   ::oWndCode = nil
   ::bValid   = nil

   if ::oDlgBuild != nil
      ::oDlgBuild:End()
   endif   

   ::End()

return nil

//----------------------------------------------------------------//

METHOD Run( cArguments, lDebug ) CLASS TWndPrj

   DEFAULT lDebug := .f.

   ::Build( lDebug )

   if File( cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) + ".exe" )
      WinExec(  cFileNoExt( ::aPrograms[ 1 ][ 1 ] ) + " " + cArguments )
   endif

return nil

//----------------------------------------------------------------//

METHOD AddItem() CLASS TWndPrj

   local cFileName

   do case
      case ::oBottom:nOption == 1
           cFileName = cGetFile( "*.prg", "Select a Program" )
           if ! Empty( cFileName )
              if ! File( cFileName )
                 MsgStop( "I can't find that file!" )
              else
                 AAdd( ::aPrograms, { cFileName, "" } )
                 ::oBrw:Refresh()
              endif
           endif

      case ::oBottom:nOption == 2
           cFileName = cGetFile( "*.ffm", "Select a Form" )
           if ! Empty( cFileName )
              if ! File( cFileName )
                 MsgStop( "I can't find that file!" )
              else
                 AAdd( ::aForms, { cFileName, "" } )
                 ::oBrw:Refresh()
              endif
           endif

      case ::oBottom:nOption == 3
           cFileName = cGetFile( "*.dbf", "Select a DataBase" )
           if ! Empty( cFileName )
              if ! File( cFileName )
                 MsgStop( "I can't find that file!" )
              else
                 AAdd( ::aDataBases, { cFileName, "" } )
                 ::oBrw:Refresh()
              endif
           endif

   endcase

return nil

//----------------------------------------------------------------//

METHOD DelItem() CLASS TWndPrj

   do case
      case ::oBottom:nOption == 1
           if Len( ::aPrograms ) > 0
              ASize( ::aPrograms, Len( ::aPrograms ) - 1 )
              ::oBrw:Refresh()
           endif

      case ::oBottom:nOption == 2
           if Len( ::aForms ) > 0
              ASize( ::aForms, Len( ::aForms ) - 1 )
              ::oBrw:Refresh()
           endif

      case ::oBottom:nOption == 3
           if Len( ::aDataBases ) > 0
              ASize( ::aDataBases, Len( ::aDataBases ) - 1 )
              ::oBrw:Refresh()
           endif
   endcase

return nil

//----------------------------------------------------------------//

METHOD GetItems() CLASS TWndPrj

   do case
      case ::oBottom:nOption == 1
           if Len( ::aPrograms ) > 0
              return { 0, Lower( cFileNoPath( ::aPrograms[ ::oBrw:nAt ][ 1 ] ) ),;
                       ::aPrograms[ ::oBrw:nAt ][ 2 ] }
           else
              return { "" }
           endif

      case ::oBottom:nOption == 2
           if Len( ::aForms ) > 0
              return { 0, Lower( cFileNoPath( ::aForms[ ::oBrw:nAt ][ 2 ] ) ),;
                       ::aForms[ ::oBrw:nAt ][ 3 ] }
           else
              return { "" }
           endif

      case ::oBottom:nOption == 3
           if Len( ::aDataBases ) > 0
              return { 0, Lower( cFileNoPath( ::aDataBases[ ::oBrw:nAt ][ 1 ] ) ),;
                       ::aDataBases[ ::oBrw:nAt ][ 2 ] }
           else
              return { "" }
           endif
   endcase

return nil

//----------------------------------------------------------------//

METHOD SelItems( nOption ) CLASS TWndPrj

   do case
      case nOption == 1
           ::oBrw:SetArray( ::aPrograms )
           ::oBrw:bLine = { || { 0, ::aPrograms[ ::oBrw:nAt ][ 1 ],;
                                    ::aPrograms[ ::oBrw:nAt ][ 2 ] } }
           ::oBrw:Refresh()

      case nOption == 2
           ::oBrw:SetArray( ::aForms )
           ::oBrw:bLine = { || { 0, ::aForms[ ::oBrw:nAt ]:cFileName,;
                                    ::aForms[ ::oBrw:nAt ]:cDescription } }
           ::oBrw:Refresh()

      case nOption == 3
           ::oBrw:SetArray( ::aDataBases )
           ::oBrw:Refresh()
   endcase

return nil

//----------------------------------------------------------------//

METHOD Setup() CLASS TWndPrj

   local oDlg, oFld, oGet1, oGet2, cCompiler, cChPath

   if ::cCompiler == nil
      ::CompilerIni()
   endif
   if ::cLinker == nil
      ::LinkerIni()
   endif

   ::cCompiler = PadR( ::cCompiler, 128 )
   ::cChPath   = PadR( ::cChPath, 128 )

   DEFINE DIALOG oDlg RESOURCE "Setup"

   REDEFINE FOLDER oFld ID 110 OF oDlg ;
      ITEMS   "C&ompiler", "&Linker", "&Resources", "&Make" ;
      DIALOGS "Compiler",  "Linker", "Resources", "Make"

   REDEFINE GET oGet1 VAR ::cCompiler   ID ID_CLIPPER   OF oFld:aDialogs[ 1 ] ;
      ACTION If( ! Empty( cCompiler := cGetFile( "*.exe", "Compiler location" ) ),;
                 ( ::cCompiler := cCompiler, oGet1:Refresh() ),)

   REDEFINE GET oGet2 VAR ::cChPath    ID ID_CHPATH    OF oFld:aDialogs[ 1 ] ;
      ACTION If( ! Empty( cChpath := cGetDir( "Header files location" ) ),;
                 ( ::cChPath := cChPath, oGet2:Refresh() ),)
      
   REDEFINE GET      ::cObjPath   ID ID_OBJPATH   OF oFld:aDialogs[ 1 ] ACTION nil
   
   REDEFINE CHECKBOX ::lMemVar    ID ID_MEMVAR    OF oFld:aDialogs[ 1 ]
   REDEFINE CHECKBOX ::lWarnings  ID ID_WARNINGS  OF oFld:aDialogs[ 1 ]
   REDEFINE CHECKBOX ::lDebug     ID ID_DEBUG     OF oFld:aDialogs[ 1 ]
   REDEFINE CHECKBOX ::lNoLines   ID ID_NOLINES   OF oFld:aDialogs[ 1 ]
   REDEFINE CHECKBOX ::lOneModule ID ID_ONEMODULE OF oFld:aDialogs[ 1 ]

   // REDEFINE RADIO    ::nLinker    ID ID_BLINKER, ID_MSLINK ;
   //                                                OF oFld:aDialogs[ 2 ]
   REDEFINE GET      ::cLinker    ID ID_LINKER    OF oFld:aDialogs[ 2 ]
   REDEFINE GET      ::cLibPath   ID ID_LIBPATH   OF oFld:aDialogs[ 2 ]
   REDEFINE CHECKBOX ::lMapFile   ID ID_MAPFILE   OF oFld:aDialogs[ 2 ]

   REDEFINE RADIO    ::nRcType    ID ID_RESEXE, ID_RESDLL ;
                                                OF oFld:aDialogs[ 3 ]
   REDEFINE RADIO    ::nRcPlace   ID ID_EXTERNAL, ID_BUILTIN ;
                                                OF oFld:aDialogs[ 3 ]
   REDEFINE GET      ::cRcName    ID ID_RCNAME  OF oFld:aDialogs[ 3 ]

   ACTIVATE DIALOG oDlg CENTERED

   if oDlg:nResult == ID_OK
      ::CompilerSave()
      ::LinkerSave()
   endif

return nil

//----------------------------------------------------------------------------//

METHOD CompilerIni() CLASS TWndPrj

   local oIni

   INI oIni FILENAME ".\Visual.ini"
      GET ::cCompiler SECTION "Compiler" ENTRY "Name" ;
         DEFAULT PadR( "c:\harbour\bin\harbour.exe", 128 ) OF oIni

      GET ::cChPath SECTION "Compiler" ENTRY "Include" ;
         DEFAULT PadR( "c:\harbour\include;c:\fwh\include", 128 ) OF oIni

      GET ::lMemVar    SECTION "Compiler" ENTRY "MemVar"    DEFAULT .t. OF oIni
      GET ::lWarnings  SECTION "Compiler" ENTRY "Warnings"  DEFAULT .t. OF oIni
      GET ::lDebug     SECTION "Compiler" ENTRY "Debug"     DEFAULT .f. OF oIni
      GET ::lNoLines   SECTION "Compiler" ENTRY "NoLines"   DEFAULT .f. OF oIni
      GET ::lOneModule SECTION "Compiler" ENTRY "OneModule" DEFAULT .t. OF oIni

   ENDINI

return nil

//----------------------------------------------------------------------------//

METHOD LinkerIni() CLASS TWndPrj

   local oIni

   INI oIni FILENAME ".\Visual.ini"
      GET ::cLinker SECTION "Linker" ENTRY "Name" ;
         DEFAULT "ilink32.exe" OF oIni

      GET ::lMapFile SECTION "Linker" ENTRY "MapFile" ;
         DEFAULT .f. OF oIni

      GET ::cRcName SECTION "Linker" ENTRY "RC" ;
         DEFAULT "brc32.exe" OF oIni

      GET ::nRcType SECTION "Linker" ENTRY "RCTYPE" ;
         DEFAULT "external" OF oIni

      if ::nRcType == "external"
         ::nRcType = 1
      else
         ::nRcType = 2
      endif

      GET ::nRcPlace SECTION "Linker" ENTRY "RCPLACE" ;
         DEFAULT 1 OF oIni
   ENDINI

return nil

//----------------------------------------------------------------------------//

METHOD CompilerSave() CLASS TWndPrj

   local oIni

   INI oIni FILENAME ".\Visual.ini"
      SET SECTION "Compiler" ENTRY "Name"      OF oIni TO ::cCompiler
      SET SECTION "Compiler" ENTRY "Include"   OF oIni TO ::cChPath
      SET SECTION "Compiler" ENTRY "MemVar"    OF oIni TO ::lMemVar
      SET SECTION "Compiler" ENTRY "Warnings"  OF oIni TO ::lWarnings
      SET SECTION "Compiler" ENTRY "Debug"     OF oIni TO ::lDebug
      SET SECTION "Compiler" ENTRY "NoLines"   OF oIni TO ::lNoLines
      SET SECTION "Compiler" ENTRY "OneModule" OF oIni TO ::lOneModule
   ENDINI

return nil

//----------------------------------------------------------------------------//

METHOD LinkerSave() CLASS TWndPrj

   local oIni

   INI oIni FILENAME ".\Visual.ini"
      SET SECTION "Linker" ENTRY "Name"    OF oIni TO ::cLinker
      SET SECTION "Linker" ENTRY "MapFile" OF oIni TO ::lMapFile

      SET SECTION "Linker" ENTRY "RcPlace"  OF oIni TO ::nRcType

      SET SECTION "Linker" ENTRY "RcType" OF oIni ;
         TO If( ::nRcType == 1, "external", "linker built-in" )

      SET SECTION "Linker" ENTRY "RC"      OF oIni TO ::cRcName
   ENDINI

return nil

//----------------------------------------------------------------------------//

METHOD Save() CLASS TWndPrj

   local cProject, cClpName, n
   local cForms  := "", cPrograms := "", cRcText := ""

   ::oWndCode:SaveAll()
   AEval( ::aForms,;
          { | oForm, n | MemoWrit( Lower( oForm:cFileName ), oForm:Save() ),;
          cForms  +=  AllTrim( Str( n ) ) + "=" + oForm:cFileName + CRLF } )

   for n := 1 to Len( ::aPrograms )
      cPrograms += LTrim( Str( n, 2 ) ) + "=" + ::aPrograms[ n ][ 1 ] + CRLF
   next
   
   cProject = "[PROGRAMS]" + CRLF + cPrograms + CRLF + ;
              "[FORMS]" + CRLF + cForms + CRLF

   if File( ::cName ) .and. MemoRead( ::cName ) != cProject
      if !  MsgYesNo( ::cName + " already exists on disk" + CRLF + ;
                      "Do you want to overwrite it ?" )
         return .f.
      endif
   else
      MemoWrit( Lower( ::cName ), cProject )
   endif

return .t.

//----------------------------------------------------------------------------//
